commit:     5876585a138a317e27542ed50331f9e6c7315cca
Author:     Patrick McLean <chutzpah <AT> gentoo <DOT> org>
AuthorDate: Tue May  3 20:30:01 2022 +0000
Commit:     Patrick McLean <chutzpah <AT> gentoo <DOT> org>
CommitDate: Tue May  3 20:30:10 2022 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=5876585a

dev-libs/openssl: add 1.1.1o

Signed-off-by: Patrick McLean <chutzpah <AT> gentoo.org>

 dev-libs/openssl/Manifest              |   2 +
 dev-libs/openssl/openssl-1.1.1o.ebuild | 298 +++++++++++++++++++++++++++++++++
 2 files changed, 300 insertions(+)

diff --git a/dev-libs/openssl/Manifest b/dev-libs/openssl/Manifest
index ddca5b64dd88..bbdc6eea0074 100644
--- a/dev-libs/openssl/Manifest
+++ b/dev-libs/openssl/Manifest
@@ -3,5 +3,7 @@ DIST openssl-1.0.2t-bindist-1.0.tar.xz 13872 BLAKE2B 
b2aade96a6e0ca6209a39e205b1
 DIST openssl-1.0.2u.tar.gz 5355412 BLAKE2B 
b2ff2a10e5851af5aca4093422a9a072c794e87b997263826c1c35910c040f695fac63decac5856cb49399ed03d410f97701d9fd4e1ebfbcacd8f3a74ce8bf57
 SHA512 
c455bb309e20e2c2d47fdc5619c734d107d5c8c38c1409903ce979acc120b0d5fa0312917c0aa0d630e402d092a703d4249643f36078e8528a3cafc9dac6ab32
 DIST openssl-1.1.1n.tar.gz 9850712 BLAKE2B 
af530258d9f7ca4f1bd1c6c344eb385e766e465c9341dd08797676165f67bbb82d3fd549ed7559dc12fb8c9c4db5e04fa6ec7ab729ec1467f5e8bce469ff5398
 SHA512 
1937796736613dcf4105a54e42ecb61f95a1cea74677156f9459aea0f2c95159359e766089632bf364ee6b0d28d661eb9957bce8fecc9d2436378d8d79e8d0a4
 DIST openssl-1.1.1n.tar.gz.asc 488 BLAKE2B 
8fc18fdc884473dc4c243499cc3528691a9ecc184e39e8d942450d41c42d22a96398036ae804af23c4f28d082c62f5babaa275ceb2e13b33b5acfd59a802c186
 SHA512 
24abc3d187cabed830dcd3189a34c2dc29e0b8013a607011a0e85cc68f0ec48c1de14a005053a4de3a4013cfa9658016ac65cfb8cfac58da55231371926beeda
+DIST openssl-1.1.1o.tar.gz 9856386 BLAKE2B 
5bd355fd17adf43ba4e3bf1a8036ceb724edd4f4ab80dc25aecc3d2647372e9db2bc12e2b89791fc4b6f7fd95a7b68e00490d09ca6518d25ab990ee27798e641
 SHA512 
75b2f1499cb4640229eb6cd35d85cbff2e19db17b959ac4d04b60f1b395b73567f9003521452a0fcfeea9b31b26de0a7bccf476ecf9caae02298f3647cfb7e23
+DIST openssl-1.1.1o.tar.gz.asc 488 BLAKE2B 
a03a967e7e2124d1a76ad7765e2f48065f40d32ba102a433be603ee8f86b26a2d246dcb97a95bd694ef3005889ce4f1951f76d39fe1d683f92da1aa3023e9c2d
 SHA512 
da6d88de7c1cd807b6089d50f8bb102c317c0b45ca26e517e3e400c5c65f787d94a1ee522af76279e93790a7fb491348cf25ffcfd66ecb9a9d35209328cb221e
 DIST openssl-3.0.2.tar.gz 15038141 BLAKE2B 
140c4c80a0cad89cb0059fef6a4cd421460e6af9a3973f7a3eb5e39f64c0d44794d46e7a869e5235fced139f2249351e37a9ee5ebaa17f2708d63141ebebf919
 SHA512 
f986850d5be908b4d6b5fd7091bc4652d7378c9bccebfbc5becd7753843c04c1eb61a1749c432139d263dfac33df0b1f6c773664b485cad47542266823a4eb03
 DIST openssl-3.0.2.tar.gz.asc 488 BLAKE2B 
2f6482114271c4f512159fa159486a3b3470637d770cd1614fda004918d06ed9ab562e655d1580d2ebb05745ec72987488c2161b72d078017cc157003d4205da
 SHA512 
4303391a58107c76ad9b05510f5bfc95f687f4cb2f9ff5b03fb262ba99b573423ab83f0437471199954496799b343191b889ad9ef8fabdd7ee4ec3ec9b5f1d81

diff --git a/dev-libs/openssl/openssl-1.1.1o.ebuild 
b/dev-libs/openssl/openssl-1.1.1o.ebuild
new file mode 100644
index 000000000000..5b19fd948893
--- /dev/null
+++ b/dev-libs/openssl/openssl-1.1.1o.ebuild
@@ -0,0 +1,298 @@
+# Copyright 1999-2022 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI="7"
+
+inherit flag-o-matic toolchain-funcs multilib-minimal verify-sig
+
+MY_P=${P/_/-}
+
+DESCRIPTION="full-strength general purpose cryptography library (including SSL 
and TLS)"
+HOMEPAGE="https://www.openssl.org/";
+SRC_URI="mirror://openssl/source/${MY_P}.tar.gz
+       verify-sig? ( mirror://openssl/source/${MY_P}.tar.gz.asc )"
+VERIFY_SIG_OPENPGP_KEY_PATH=${BROOT}/usr/share/openpgp-keys/openssl.org.asc
+
+LICENSE="openssl"
+SLOT="0/1.1" # .so version of libssl/libcrypto
+[[ "${PV}" = *_pre* ]] || \
+KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~ia64 ~loong ~m68k ~mips ~ppc ~ppc64 
~riscv ~s390 ~sparc ~x86 ~x64-cygwin ~amd64-linux ~x86-linux ~ppc-macos 
~x64-macos ~sparc-solaris ~sparc64-solaris ~x64-solaris ~x86-solaris ~x86-winnt"
+IUSE="+asm rfc3779 sctp cpu_flags_x86_sse2 sslv3 static-libs test 
tls-compression tls-heartbeat vanilla verify-sig weak-ssl-ciphers"
+RESTRICT="!test? ( test )"
+
+RDEPEND=">=app-misc/c_rehash-1.7-r1
+       tls-compression? ( 
>=sys-libs/zlib-1.2.8-r1[static-libs(+)?,${MULTILIB_USEDEP}] )"
+DEPEND="${RDEPEND}"
+BDEPEND="
+       >=dev-lang/perl-5
+       sctp? ( >=net-misc/lksctp-tools-1.0.12 )
+       test? (
+               sys-apps/diffutils
+               sys-devel/bc
+               kernel_linux? ( sys-process/procps )
+       )
+       verify-sig? ( sec-keys/openpgp-keys-openssl )"
+PDEPEND="app-misc/ca-certificates"
+
+PATCHES=(
+       "${FILESDIR}"/${PN}-1.1.0j-parallel_install_fix.patch #671602
+       "${FILESDIR}"/${PN}-1.1.1i-riscv32.patch
+)
+
+S="${WORKDIR}/${MY_P}"
+
+# force upgrade to prevent broken login, bug 696950
+RDEPEND+=" !<net-misc/openssh-8.0_p1-r3"
+
+MULTILIB_WRAPPED_HEADERS=(
+       usr/include/openssl/opensslconf.h
+)
+
+pkg_setup() {
+       [[ ${MERGE_TYPE} == binary ]] && return
+
+       # must check in pkg_setup; sysctl don't work with userpriv!
+       if use test && use sctp; then
+               # test_ssl_new will fail with "Ensure SCTP AUTH chunks are 
enabled in kernel"
+               # if sctp.auth_enable is not enabled.
+               local sctp_auth_status=$(sysctl -n net.sctp.auth_enable 
2>/dev/null)
+               if [[ -z "${sctp_auth_status}" ]] || [[ ${sctp_auth_status} != 
1 ]]; then
+                       die "FEATURES=test with USE=sctp requires 
net.sctp.auth_enable=1!"
+               fi
+       fi
+}
+
+src_prepare() {
+       # allow openssl to be cross-compiled
+       cp "${FILESDIR}"/gentoo.config-1.0.2 gentoo.config || die
+       chmod a+rx gentoo.config || die
+
+       # keep this in sync with app-misc/c_rehash
+       SSL_CNF_DIR="/etc/ssl"
+
+       # Make sure we only ever touch Makefile.org and avoid patching a file
+       # that gets blown away anyways by the Configure script in src_configure
+       rm -f Makefile
+
+       if ! use vanilla ; then
+               if [[ $(declare -p PATCHES 2>/dev/null) == "declare -a"* ]] ; 
then
+                       [[ ${#PATCHES[@]} -gt 0 ]] && eapply "${PATCHES[@]}"
+               fi
+       fi
+
+       eapply_user #332661
+
+       if use test && use sctp && has network-sandbox ${FEATURES}; then
+               ebegin "Disabling test '80-test_ssl_new.t' which is known to 
fail with FEATURES=network-sandbox"
+               rm test/recipes/80-test_ssl_new.t || die
+               eend $?
+       fi
+
+       # make sure the man pages are suffixed #302165
+       # don't bother building man pages if they're disabled
+       # Make DOCDIR Gentoo compliant
+       sed -i \
+               -e '/^MANSUFFIX/s:=.*:=ssl:' \
+               -e '/^MAKEDEPPROG/s:=.*:=$(CC):' \
+               -e $(has noman FEATURES \
+                       && echo '/^install:/s:install_docs::' \
+                       || echo '/^MANDIR=/s:=.*:='${EPREFIX}'/usr/share/man:') 
\
+               -e "/^DOCDIR/s@\$(BASENAME)@&-${PVR}@" \
+               Configurations/unix-Makefile.tmpl \
+               || die
+
+       # quiet out unknown driver argument warnings since openssl
+       # doesn't have well-split CFLAGS and we're making it even worse
+       # and 'make depend' uses -Werror for added fun (#417795 again)
+       [[ ${CC} == *clang* ]] && append-flags -Qunused-arguments
+
+       append-flags -fno-strict-aliasing
+       append-flags $(test-flags-CC -Wa,--noexecstack)
+       append-cppflags -DOPENSSL_NO_BUF_FREELISTS
+
+       # Prefixify Configure shebang (#141906)
+       sed \
+               -e "1s,/usr/bin/env,${EPREFIX}&," \
+               -i Configure || die
+       # Remove test target when FEATURES=test isn't set
+       if ! use test ; then
+               sed \
+                       -e '/^$config{dirs}/s@ "test",@@' \
+                       -i Configure || die
+       fi
+
+       if use prefix && [[ ${CHOST} == *-solaris* ]] ; then
+               # use GNU ld full option, not to confuse it on Solaris
+               sed -i \
+                       -e 's/-Wl,-M,/-Wl,--version-script=/' \
+                       -e 's/-Wl,-h,/-Wl,--soname=/' \
+                       Configurations/10-main.conf || die
+
+               # fix building on Solaris 10
+               # https://github.com/openssl/openssl/issues/6333
+               sed -i \
+                       -e 's/-lsocket -lnsl -ldl/-lsocket -lnsl -ldl -lrt/' \
+                       Configurations/10-main.conf || die
+       fi
+
+       # The config script does stupid stuff to prompt the user.  Kill it.
+       sed -i '/stty -icanon min 0 time 50; read waste/d' config || die
+       ./config --test-sanity || die "I AM NOT SANE"
+
+       multilib_copy_sources
+}
+
+multilib_src_configure() {
+       unset APPS #197996
+       unset SCRIPTS #312551
+       unset CROSS_COMPILE #311473
+
+       tc-export CC AR RANLIB RC
+
+       use_ssl() { usex $1 "enable-${2:-$1}" "no-${2:-$1}" " ${*:3}" ; }
+       echoit() { echo "$@" ; "$@" ; }
+
+       local krb5=$(has_version app-crypt/mit-krb5 && echo "MIT" || echo 
"Heimdal")
+
+       # See if our toolchain supports __uint128_t.  If so, it's 64bit
+       # friendly and can use the nicely optimized code paths. #460790
+       local ec_nistp_64_gcc_128
+       # Disable it for now though #469976
+       # echo "__uint128_t i;" > "${T}"/128.c
+       # if ${CC} ${CFLAGS} -c "${T}"/128.c -o /dev/null >&/dev/null ; then
+       #       ec_nistp_64_gcc_128="enable-ec_nistp_64_gcc_128"
+       # fi
+
+       local sslout=$(./gentoo.config)
+       einfo "Use configuration ${sslout:-(openssl knows best)}"
+       local config="Configure"
+       [[ -z ${sslout} ]] && config="config"
+
+       # "disable-deprecated" option breaks too many consumers.
+       # Don't set it without thorough revdeps testing.
+       # Make sure user flags don't get added *yet* to avoid duplicated
+       # flags.
+       CFLAGS= LDFLAGS= echoit \
+       ./${config} \
+               ${sslout} \
+               $(use cpu_flags_x86_sse2 || echo "no-sse2") \
+               enable-camellia \
+               enable-ec \
+               enable-ec2m \
+               enable-sm2 \
+               enable-srp \
+               $(use elibc_musl && echo "no-async") \
+               ${ec_nistp_64_gcc_128} \
+               enable-idea \
+               enable-mdc2 \
+               enable-rc5 \
+               $(use_ssl sslv3 ssl3) \
+               $(use_ssl sslv3 ssl3-method) \
+               $(use_ssl asm) \
+               $(use_ssl rfc3779) \
+               $(use_ssl sctp) \
+               $(use_ssl tls-compression zlib) \
+               $(use_ssl tls-heartbeat heartbeats) \
+               $(use_ssl weak-ssl-ciphers) \
+               --prefix="${EPREFIX}"/usr \
+               --openssldir="${EPREFIX}"${SSL_CNF_DIR} \
+               --libdir=$(get_libdir) \
+               shared threads \
+               || die
+
+       # Clean out hardcoded flags that openssl uses
+       local DEFAULT_CFLAGS=$(grep ^CFLAGS= Makefile | LC_ALL=C sed \
+               -e 's:^CFLAGS=::' \
+               -e 's:\(^\| \)-fomit-frame-pointer::g' \
+               -e 's:\(^\| \)-O[^ ]*::g' \
+               -e 's:\(^\| \)-march=[^ ]*::g' \
+               -e 's:\(^\| \)-mcpu=[^ ]*::g' \
+               -e 's:\(^\| \)-m[^ ]*::g' \
+               -e 's:^ *::' \
+               -e 's: *$::' \
+               -e 's: \+: :g' \
+               -e 's:\\:\\\\:g'
+       )
+
+       # Now insert clean default flags with user flags
+       sed -i \
+               -e "/^CFLAGS=/s|=.*|=${DEFAULT_CFLAGS} ${CFLAGS}|" \
+               -e "/^LDFLAGS=/s|=[[:space:]]*$|=${LDFLAGS}|" \
+               Makefile || die
+}
+
+multilib_src_compile() {
+       # depend is needed to use $confopts; it also doesn't matter
+       # that it's -j1 as the code itself serializes subdirs
+       emake -j1 depend
+       emake all
+}
+
+multilib_src_test() {
+       emake -j1 test
+}
+
+multilib_src_install() {
+       # We need to create $ED/usr on our own to avoid a race condition #665130
+       if [[ ! -d "${ED}/usr" ]]; then
+               # We can only create this directory once
+               mkdir "${ED}"/usr || die
+       fi
+
+       emake DESTDIR="${D}" install
+
+       # This is crappy in that the static archives are still built even
+       # when USE=static-libs.  But this is due to a failing in the openssl
+       # build system: the static archives are built as PIC all the time.
+       # Only way around this would be to manually configure+compile openssl
+       # twice; once with shared lib support enabled and once without.
+       if ! use static-libs; then
+               rm "${ED}"/usr/$(get_libdir)/lib{crypto,ssl}.a || die
+       fi
+}
+
+multilib_src_install_all() {
+       # openssl installs perl version of c_rehash by default, but
+       # we provide a shell version via app-misc/c_rehash
+       rm "${ED}"/usr/bin/c_rehash || die
+
+       dodoc CHANGES* FAQ NEWS README doc/*.txt doc/${PN}-c-indent.el
+
+       # create the certs directory
+       keepdir ${SSL_CNF_DIR}/certs
+
+       # Namespace openssl programs to prevent conflicts with other man pages
+       cd "${ED}"/usr/share/man || die
+       local m d s
+       for m in $(find . -type f | xargs grep -L '#include') ; do
+               d=${m%/*} ; d=${d#./} ; m=${m##*/}
+               [[ ${m} == openssl.1* ]] && continue
+               [[ -n $(find -L ${d} -type l) ]] && die "erp, broken links 
already!"
+               mv ${d}/{,ssl-}${m}
+               # fix up references to renamed man pages
+               sed -i '/^[.]SH "SEE ALSO"/,/^[.]/s:\([^(, ]*(1)\):ssl-\1:g' 
${d}/ssl-${m}
+               ln -s ssl-${m} ${d}/openssl-${m}
+               # locate any symlinks that point to this man page ... we assume
+               # that any broken links are due to the above renaming
+               for s in $(find -L ${d} -type l) ; do
+                       s=${s##*/}
+                       rm -f ${d}/${s}
+                       # We don't want to "|| die" here
+                       ln -s ssl-${m} ${d}/ssl-${s}
+                       ln -s ssl-${s} ${d}/openssl-${s}
+               done
+       done
+       [[ -n $(find -L ${d} -type l) ]] && die "broken manpage links found :("
+
+       dodir /etc/sandbox.d #254521
+       echo 'SANDBOX_PREDICT="/dev/crypto"' > "${ED}"/etc/sandbox.d/10openssl
+
+       diropts -m0700
+       keepdir ${SSL_CNF_DIR}/private
+}
+
+pkg_postinst() {
+       ebegin "Running 'c_rehash ${EROOT}${SSL_CNF_DIR}/certs/' to rebuild 
hashes #333069"
+       c_rehash "${EROOT}${SSL_CNF_DIR}/certs" >/dev/null
+       eend $?
+}

Reply via email to